
#/scp:root@s:/usr/lib/enigma2/python/Plugins/Extensions/NetVolFor/plugin.py
from Plugins.Plugin import PluginDescriptor
from Components.HdmiCec import HdmiCec
from enigma import eActionMap
from sys import maxint
import socket

def debug(str):
    return
    with open('/tmp/NetVolFor.log', 'a') as d:
        d.write(str + '\n')

class NetVolFor():

    def __init__(self):
        debug('NetVolFor.__init__')
	eActionMap.getInstance().unbindAction('', HdmiCec.instance.keyEvent)
	eActionMap.getInstance().bindAction('', -maxint - 1, self.keyEvent)

    def keyEvent(self, keyCode, keyEvent):
	if not HdmiCec.instance.volumeForwardingEnabled: return 0
        debug('NetVolFor.keyEvent ' + str(keyCode) + ' ' + str(keyEvent))

        if keyCode == 115:
            # vol+ CEC 0x44 0x41
            cmd = '\x00\x17\x00bashRemote.iapp.samsung\x24\x00d\x00\x0C\x00MTAuMS4xLjM=\x00\x00\x10\x00YmFzaFJlbW90ZQ==\x00\x17\x00bashRemote.iapp.samsung\x02\x00\xC8\x00\x00\x21\x00bashRemote.UE46D6500.iapp.samsung\x11\x00\x00\x00\x00\x0C\x00S0VZX1ZPTFVQ'
        elif keyCode == 114:
            # vol- CEC 0x44 0x42
            cmd = '\x00\x17\x00bashRemote.iapp.samsung\x24\x00d\x00\x0C\x00MTAuMS4xLjM=\x00\x00\x10\x00YmFzaFJlbW90ZQ==\x00\x17\x00bashRemote.iapp.samsung\x02\x00\xC8\x00\x00\x21\x00bashRemote.UE46D6500.iapp.samsung\x15\x00\x00\x00\x00\x10\x00S0VZX1ZPTERPV04='
        elif keyCode == 113:
            # mute CEC 0x44 0x43
            cmd = '\x00\x17\x00bashRemote.iapp.samsung\x24\x00d\x00\x0C\x00MTAuMS4xLjM=\x00\x00\x10\x00YmFzaFJlbW90ZQ==\x00\x17\x00bashRemote.iapp.samsung\x02\x00\xC8\x00\x00\x21\x00bashRemote.UE46D6500.iapp.samsung\x11\x00\x00\x00\x00\x0C\x00S0VZX01VVEU='
        else:
            # key not handled
            return 0

        if keyEvent == 1:
            # key release handled
            return 1
        elif keyEvent != 0 and keyEvent != 2:
            # other type of event not handled
            return 0

        # key press
        debug('NetVolFor.keyEvent send')
        try:
            device = socket.create_connection(('192.168.1.5',55000),timeout=1)
            device.send(cmd)
            device.close()
        except: pass

        return 1

def main(session, **kwargs):
    return

def Plugins(**kwargs):
    NetVolFor.instance = NetVolFor()
    return PluginDescriptor(
        name = "Network volume forwarder",
        description = "Sends volume keys to TV over the network",
        where = PluginDescriptor.WHERE_PLUGINMENU,
        fnc = main)
